const app = getApp()
import WxValidate from '../../utils/wxValidate'
import { is_use_project } from '../../utils/dict';

Page({

    /**
     * 页面的初始数据
     */
    data: {
        frameStyle: { useTop: true, name: '信息管理', leftArrow: true, useBar: false },
        id: '',
        // 裁判列表
        referee_idList: [],
        // 是否使用
        is_useList: is_use_project,
        form: {}

    },
    initValidate() {
        const rules = { name: { required: true }, referee_id: { required: false }, remark: { required: false }, is_use: { required: false } }
        // 验证字段的提示信息，若不传则调用默认的信息
        const messages = { name: { required: '请输入场地名称', }, referee_id: { required: '请选择裁判', }, remark: { required: '请输入备注', }, is_use: { required: '请选择是否使用' } };
        this.WxValidate = new WxValidate(rules, messages)
    },
    // 返回
    back: function () {
        wx.navigateBack({ delta: 1 })
    },
    // 选择裁判
    referee_idChange: function (e) {
        const that = this;
        let index = e.detail.value;
        let value = that.data.referee_idList[index];
        that.setData({ 'form.referee_id': value.openid });
        that.setData({ 'form.referee_name': value.name });
    },
    // 是否使用
    is_useChange: function (e) {
        const that = this;
        let index = e.detail.value;
        let value = that.data.is_useList[index];
        that.setData({ 'form.is_use': value.value });
    },
    // 提交登录
    onSubmit: async function (e) {
        const that = this;
        const params = e.detail.value;
        const data = that.data.form;
        if (!this.WxValidate.checkForm(params)) {
            const error = this.WxValidate.errorList[0];
            wx.showToast({ title: `${error.msg}`, icon: 'error', duration: 2000 })
            return false
        } else {
            let arr;
            if (data._id) arr = await app.$post(`/newCourt/api/ground/${data._id}`, params);
            else arr = await app.$post(`/newCourt/api/ground`, params);
            if (arr.errcode == '0') { wx.showToast({ title: `维护信息完成`, icon: 'success', duration: 2000 }); that.back(); }
            else wx.showToast({ title: `${error.msg}`, icon: 'error', duration: 2000 })

        }
    },
    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        const that = this;
        that.setData({ id: options.id || '' })
        //验证规则函数
        that.initValidate();
        // 监听用户是否登录
        that.watchLogin();
    },
    // 监听用户是否登录
    watchLogin: async function () {
        const that = this;
        wx.getStorage({
            key: 'user',
            success: async res => {
                const arr = await app.$get(`/newCourt/api/user`, { type: 1, skip: 0, limit: 1000 });
                if (arr.errcode == '0') { that.setData({ referee_idList: arr.data }); }
                if (that.data.id) {
                    const arr = await app.$get(`/newCourt/api/ground/${that.data.id}`);
                    if (arr.errcode == '0') {
                        let user = that.data.referee_idList.find((i) => i.openid == arr.data.referee_id);
                        if (user) arr.data.referee_name = user.name;
                        that.setData({ form: arr.data });
                    }
                }


            },
            fail: res => {
                wx.redirectTo({ url: '/pages/index/index', })
            }
        })
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage: function () {

    }
})